# Conservative Offline Model-based Policy Optimization (COMBO)

Code to reproduce the experiments in COMBO: Conservative Offline Model-Based Policy Optimization.



## Installation
1. Install [MuJoCo 1.50](https://www.roboti.us/index.html) at `~/.mujoco/mjpro150` and copy your license key to `~/.mujoco/mjkey.txt`
2. For running D4RL, install D4RL at https://github.com/rail-berkeley/d4rl.git. 
3. Create a conda environment and install COMBO
```
cd combo
conda env create -f environment/gpu-env.yml
conda activate combo
pip install -e viskit
pip install -e .
```

## Usage
Configuration files can be found in `examples/config/`. For example, run the following command to run HalfCheetah-medium benchmark in D4RL.

```
combo run_local examples.development --config=examples.config.d4rl.halfcheetah_medium --gpus=1 --trial-gpus=1
```

Currently only running locally is supported.


#### Logging

This codebase contains [viskit](https://github.com/vitchyr/viskit) as a submodule. You can view saved runs with:
```
viskit ~/ray_combo --port 6008
```
assuming you used the default [`log_dir`](examples/config/halfcheetah/0.py#L7).
