from copy import deepcopy

from .common import common_params

params = deepcopy(common_params)
params.update({
    'type': 'COMBO',
    'domain': 'halfcheetah',
    'task': 'medium-replay-v0',
    'exp_name': 'halfcheetah_medium-replay_nolip_len5_minq_0.5_lagrange_0.0_deterministic_backup_lr1e-4_3layers_normalize_for_fake_states_fix_real0.5_rollout_random'
})
params['kwargs'].update({
    'lr': 1e-4,#3e-5,
    'q_lr': 3e-4,
    # min Q
    'with_min_q': True,#Tru5
    'min_q_for_real': False,
    'min_q_for_real_and_fake': False,
    'min_q_for_fake_only': False,
    'min_q_for_fake_states': True,
    'min_q_for_real_fake_states': False,
    'backup_for_one_step': False,
    'temp': 10.0,
    'min_q_version': 3,
    'min_q_weight': 0.5,#5.0,
    'data_subtract': True,#True,
    # extra params
    'num_random': 10,
    'max_q_backup': False,
    'deterministic_backup': True,
    # lagrange
    'with_lagrange': False,#True,
    'lagrange_thresh': 5.0,

    'model_train_freq': 1000,
    'model_retain_epochs': 10,
    'rollout_batch_size': 10e3,
    'deterministic': False,
    'rollout_random': True,
    'num_networks': 7,
    'num_elites': 5,
    'real_ratio': 0.5,#0.8,#0.05,#0.5,
    'target_entropy': -3,
    'max_model_t': None,
    'rollout_length': 5,#10, #### 1, 5, 10, 15, 20, 25 

    'restore': False,
    'cross_validate': False,
    'cross_validate_model_eval': False,
    'cross_validate_eval_n_episodes': 20,
    'cross_validate_n_steps': 5,

    'sn': False,#True,
    'separate_mean_var': False,#True,
    'penalty_learned_var': False,#True,
    'penalty_coeff': 0.0, #1.0
    'pool_load_path': 'd4rl/halfcheetah-medium-replay-v0',
    'pool_load_max_size': 2 * 10**6,
    'model_name': 'halfcheetah-medium-replay_sn_smv_1_0',
})