from copy import deepcopy

from .common import common_params

params = deepcopy(common_params)
params.update({
    'type': 'COMBO',
    'domain': 'hopper',
    'task': 'medium-v0',
    'exp_name': 'hopper_medium_nolip_len5_minq_3.0_lagrange_0.0_deterministic_backup_temp1.0_lr3e-5_3layers_normalize_for_fake_states_rollout_random_real0.5_iter2000'
})
params['kwargs'].update({
    'lr': 3e-5,#3e-5,
    'q_lr': 3e-4,
    # min Q
    'with_min_q': True,#Tru5
    'min_q_for_real': False,
    'min_q_for_real_and_fake': False,
    'min_q_for_fake_only': False,
    'min_q_for_fake_states': True,
    'backup_with_uniform': False,
    'backup_for_fake_only': False,
    'temp': 1.0,#10.0,
    'min_q_version': 3,
    'min_q_weight': 3.0,#5.0,
    'data_subtract': True,#True,
    # extra params
    'num_random': 10,#10,
    'max_q_backup': False,
    'deterministic_backup': True,
    # lagrange
    'with_lagrange': False,#True,
    'lagrange_thresh': 5.0,

    'model_train_freq': 1000,
    'model_retain_epochs': 10,
    'rollout_batch_size': 10e3,
    'deterministic': False,
    'rollout_random': True,
    'num_networks': 7,
    'num_elites': 5,
    'real_ratio': 0.5,#0.5,#0.05,#0.5,
    'target_entropy': -3,
    'max_model_t': None,
    'rollout_length': 5,#10, #### 1, 5, 10, 15, 20, 25
    # 'hidden_dim': 128,
    # 'num_layers': 4,
    'multi_step_prediction': False,
    'num_plan_steps': 5,#10,
    # 'model_lr': 1e-4,

    # cross-validation
    'restore': False,
    'cross_validate': False,
    'cross_validate_model_eval': False,#True,
    'cross_validate_eval_n_episodes': 10,
    'cross_validate_n_steps': 5,
    'use_fqe': False,
    'fqe_num_qs': 3,
    'fqe_minq': False,

    'sn': False,#True,
    'separate_mean_var': False,#True,
    'penalty_learned_var': False,#True,
    'penalty_coeff': 0.0, #1.0
    'pool_load_path': 'd4rl/hopper-medium-v0',
    'pool_load_max_size': 2 * 10**6,
    'model_name': 'hopper-medium_sn_smv_1_0',
})