from copy import deepcopy

from .common import common_params

params = deepcopy(common_params)
params.update({
    'type': 'COMBO',
    'domain': 'walker2d',
    'task': 'medium-expert-v0',
    'exp_name': 'walker2d_medium-expert_nolip_len1_minq_5.0_lagrange_0.0_temp10.0_deterministic_backup_lr1e-5_qlr1e-4_3layers_normalize_for_real_fake_states_real0.5_fix_model_new_iter3000'
})
params['kwargs'].update({
    'lr': 1e-5,#3e-5,
    'q_lr': 1e-4,
    # min Q
    'with_min_q': True,#Tru5
    'min_q_for_real': False,
    'min_q_for_real_and_fake': False,
    'min_q_for_fake_only': False,
    'min_q_for_fake_states': True,
    'min_q_for_real_fake_states': True,
    'backup_for_fake_only': False,
    'backup_with_uniform': False,
    'learn_bc_policy': False,
    'learn_bc_epoch': 50,
    'temp': 10.0,#10.0,
    'min_q_version': 3,
    'min_q_weight': 5.0,#0.5,#5.0,
    'data_subtract': True,#True,
    # extra params
    'num_random': 10,
    'max_q_backup': False,
    'deterministic_backup': True,
    # lagrange
    'with_lagrange': False,#True,
    'lagrange_thresh': 0.0,

    'model_train_freq': 1000,
    'model_retain_epochs': 10,
    'rollout_batch_size': 10e3,
    'deterministic': False,
    'rollout_random': False,#True,
    'rollout_half_random': False,#True,
    # 'num_repeat': 3,
    'num_networks': 7,
    'num_elites': 5,
    'real_ratio': 0.5,#0.05,#0.5,
    'target_entropy': -3,
    'max_model_t': None,
    'rollout_length': 1,#10, #### 1, 5, 10, 15, 20, 25 
    'multi_step_prediction': False,
    'num_plan_steps': 10,#10,

    # cross-validation
    'restore': False,
    'cross_validate': False,
    'cross_validate_model_eval': False,
    'cross_validate_eval_n_episodes': 10,
    'cross_validate_n_steps': 5,
    'use_fqe': False,
    'fqe_num_qs': 3,
    'fqe_minq': False,

    'sn': False,#True,
    'separate_mean_var': False,#True,
    'penalty_learned_var': False,#True,
    'penalty_coeff': 0.0, #1.0
    'pool_load_path': 'd4rl/walker2d-medium-expert-v0',
    'pool_load_max_size': 2 * 10**6,
    'model_name': 'walker2d-medium-expert_sn_smv_1_0',

})